
#import <UIKit/UIKit.h>

//アングル
typedef enum{
	MOVANGL_FRONT		=0,	//正面
	MOVANGL_LEFT		=1,	//左
	MOVANGL_RIGHT		=2,	//右
	MOVANGL_BACK		=3,	//後ろ
} MovAngleType;

//タイプ （追加）
typedef enum{
	TYPE_RABBIT			=0,	//うさぎ
	TYPE_WLOF			=1,	//オオカミ
} PieceType;

//ステータス（追加）
typedef enum{
	STATE_STAY			=0,	//停止
	STATE_MOVEING		=1,	//移動
} PieceState;



@class	GameBoardTile;

@interface GamePieceView : UIView {
	
	id				delegate;
	NSArray*		imageArray;
	int				imageIndex;
	int				animeIndex;
	CGPoint			moveLocation;
	BOOL			isMoveing;
	float			speed;
	PieceType		type;		//タイプ （追加）
	PieceState		state;		//ステータス（追加）
	
	GameBoardTile*	tile;		//現在の位置
	GameBoardTile*	targetTile;	//最終移動位置
	GameBoardTile*	nextTile;	//次の移動位置
	
	double			delay_mov;
	MovAngleType	checkAngle;
	NSTimer*		moveTimer;
}

@property (nonatomic, assign) id				delegate;
@property (nonatomic, retain) NSArray*			imageArray;
@property (nonatomic, assign) int				imageIndex;
@property (nonatomic, assign) float				speed;
@property (nonatomic, assign) PieceType			type;//（追加）
@property (nonatomic, assign) PieceState		state;//（追加）
@property (nonatomic, assign) BOOL				isMoveing;
@property (nonatomic, retain) GameBoardTile*	tile;
@property (nonatomic, retain) GameBoardTile*	targetTile;
@property (nonatomic, retain) GameBoardTile*	nextTile;

-(id)initWithFrame:(CGRect)frame Images:(NSArray*)images Delegate:(id)del;
-(void)moveWith:(GameBoardTile*)movTile;
-(void)movePosition:(CGPoint)position;
-(void)moveCancelPosition;

-(void)timerStart;
-(void)timerStop;
-(void)moveAction:(NSTimer*)timer;

-(void)update;

@end


//プロトコル宣言
@protocol GamePieceViewDelegate

-(void) gamePieceCAMoveStart:(GamePieceView*)piece Position:(CGPoint)pt;
-(void) gamePieceCAMoveEnd:(GamePieceView*)piece Position:(CGPoint)pt Finish:(BOOL)isFinish;

-(GameBoardTile*)gamePieceNextMovTile:(GamePieceView*)piece;
-(GameBoardTile*)gamePieceTargetMovTile:(GamePieceView*)piece;	//（追加）
-(BOOL)gamePieceIsMoveFinish:(GamePieceView*)piece;				//（追加）

@end


